=== debian/changelog ===
arm-trusted-firmware (2.8.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * debian/control: Add openssl to Build-Depends.
  * debian/rules: Move sun50i_a64 to platforms_nodebug.
  * debian/patches: Refresh for 2.8.0.
  * debian/copyright: Update for 2.8.0.

 -- Vagrant Cascadian <vagrant@debian.org>  Thu, 24 Nov 2022 22:31:44 -0800
