=== debian/changelog ===
arm-trusted-firmware (2.9.0+dfsg-3) unstable; urgency=medium

  * Upload to unstable.

 -- Vagrant Cascadian <vagrant@debian.org>  Fri, 30 Jun 2023 18:17:00 -0700

arm-trusted-firmware (2.9.0+dfsg-2) experimental; urgency=medium

  * debian/rules: Fix variable assignment for sun50i_h6_no_pmic target.

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 18 Jun 2023 20:42:17 -0700

arm-trusted-firmware (2.9.0+dfsg-1) experimental; urgency=medium

  [ Manuel Traut ]
  * Build for i.MX8MM

  [ Vagrant Cascadian ]
  * debian/copyright: Update for 2.9.0.
  * debian/control: Update Standards-Version to 4.6.2.
  * debian/rules: Build sun50i_a64 with debugging enabled again.

  [ Detlev Casanova ]
  * debian/patches: Add mandatory fields in reserved-memory node
  * debian/rules: Add platform target specifiers
  * debian/rules: Also build bl31 for the rcar platform

  [ Vagrant Cascadian ]
  * debian/rules: Disable imx8mq, as it is not well supported upstream.

  [ harry88@gmx.ph ]
  * debian/rules: Add sun50i_h6 subplatform without PMIC regulators.
    (Closes: #1032395)

 -- Vagrant Cascadian <vagrant@debian.org>  Sun, 18 Jun 2023 20:26:00 -0700
